import {createRouter, createWebHistory} from 'vue-router'
import demoRouter from './modules/demo'
import Temp404 from '@/views/global/temp/404.vue'
import RouterView from '@/layout/router-view.vue'
// @ts-ignore
import Layout from '@/layout/index.vue'
import {useMenuStore} from "@/stores";
import {login} from "@/views/smart-ask-answer/assistant/dify/common";

const routes = [
    demoRouter,
    { path: '/:pathMatch(.*)*', name: 'NotFound', component: Temp404 },
    {
        name: 'root',
        path: '/',
        component: Layout,
        redirect: '/assistant',
        children: [
        ]
    },
    {
        name: 'assistant',
        path: '/assistant',
        component: () => import('@/views/smart-ask-answer/assistant/index.vue'),
    }
]

const router = createRouter({
    // @ts-ignore
    history: createWebHistory(import.meta.env.BASE_URL),
    routes,
});
router.beforeEach((to, from , next) => {
    next()
})
// export const initRoutes = () => {
//     const MenuStore = useMenuStore()
//     return new Promise((resolve, reject) => {
//         setTimeout(() => {
//             MenuStore.initRoutes(MenuStore.mockApi)
//             resolve(null)
//         }, 1000)
//     })
// }
export const beforeInit = () => {
    if (location.pathname === (import.meta as any).env.BASE_URL + 'assistant') {
        const loginData = {
            email: 'guest@qq.com',
            password: 'tj123456',
            language: 'zh-Hans',
            remember_me: true,
            anonymous: true
        }
        login({
            url: '/login',
            body: loginData,
        }).then((res: any) => {
            localStorage.setItem('console_token', res.data.access_token)
            localStorage.setItem('refresh_token', res.data.refresh_token)
            const l = document.getElementById('loader')
            if (l) {
                l.style.display = 'none'
            }
        })
    }
}
export default router;
